commit fc95eef85318824e0590255bb62d67433ea6e86e
Author: freddy77 <freddy77>
Date:   Wed Dec 3 08:37:10 2008 +0000

    improve lookup routines

diff --git a/ChangeLog b/ChangeLog
index 8839590..33a643e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Dec 03 09:35:32 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/ctlib/cs.c src/dblib/dblib.c: avoid possible buffer overflow
+	* src/dblib/dbutil.c: make message const
+	* src/odbc/odbc.c: make odbc_prret thread safe
+
 Tue Dec 02 11:53:14 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/unittests/t0013.c: avoid leak
 
@@ -982,4 +987,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2667 2008/12/02 10:54:37 freddy77 Exp $
+$Id: ChangeLog,v 1.2668 2008/12/03 08:37:10 freddy77 Exp $
diff --git a/src/ctlib/cs.c b/src/ctlib/cs.c
index a759a52..fd5fa07 100644
--- a/src/ctlib/cs.c
+++ b/src/ctlib/cs.c
@@ -50,7 +50,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: cs.c,v 1.67 2008/08/26 14:14:33 freddy77 Exp $");
+TDS_RCSID(var, "$Id: cs.c,v 1.68 2008/12/03 08:37:11 freddy77 Exp $");
 
 static int _cs_datatype_length(int dtype);
 static CS_INT cs_diag_storemsg(CS_CONTEXT *context, CS_CLIENTMSG *message);
@@ -61,7 +61,7 @@ static CS_INT cs_diag_countmsg(CS_CONTEXT *context, CS_INT *count);
 const char *
 cs_prretcode(int retcode)
 {
-	static char unknown[12]="oops: ";
+	static char unknown[24];
 	
 	switch(retcode) {
 	case CS_SUCCEED:	return "CS_SUCCEED";
@@ -86,7 +86,7 @@ cs_prretcode(int retcode)
 	case CS_TIMED_OUT:	return "CS_TIMED_OUT";
 
 	default:
-		sprintf(unknown + 6, "%u ??", retcode);
+		sprintf(unknown, "oops: %u ??", retcode);
 	}
 	return unknown;
 }
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index f23ac5d..655f28a 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.331 2008/11/18 01:16:49 jklowden Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.332 2008/12/03 08:37:11 freddy77 Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -1481,7 +1481,7 @@ dbexit()
 static const char *
 prdbresults_state(int retcode)
 {
-	static char unknown[12]="oops: ";
+	static char unknown[24];
 	switch(retcode) {
 	case _DB_RES_INIT:		return "_DB_RES_INIT";
 	case _DB_RES_RESULTSET_EMPTY:	return "_DB_RES_RESULTSET_EMPTY";
@@ -1490,7 +1490,7 @@ prdbresults_state(int retcode)
 	case _DB_RES_NO_MORE_RESULTS:	return "_DB_RES_NO_MORE_RESULTS";
 	case _DB_RES_SUCCEED:		return "_DB_RES_SUCCEED";
 	default:
-		sprintf(unknown + 6, "%u ??", retcode);
+		sprintf(unknown, "oops: %u ??", retcode);
 	}
 	return unknown;
 }
@@ -1498,7 +1498,7 @@ prdbresults_state(int retcode)
 static const char *
 prdbretcode(int retcode)
 {
-	static char unknown[12]="oops: ";
+	static char unknown[24];
 	switch(retcode) {
 	case REG_ROW:		return "REG_ROW/MORE_ROWS";
 	case NO_MORE_ROWS:	return "NO_MORE_ROWS";
@@ -1507,7 +1507,7 @@ prdbretcode(int retcode)
 	case SUCCEED:		return "SUCCEED";
 	case FAIL:		return "FAIL";
 	default:
-		sprintf(unknown + 6, "%u ??", retcode);
+		sprintf(unknown, "oops: %u ??", retcode);
 	}
 	return unknown;
 }
@@ -1515,14 +1515,14 @@ prdbretcode(int retcode)
 static const char *
 prretcode(int retcode)
 {
-	static char unknown[12]="oops";
+	static char unknown[24];
 	switch(retcode) {
 	case TDS_SUCCEED:		return "TDS_SUCCEED";
 	case TDS_FAIL:			return "TDS_FAIL";
 	case TDS_NO_MORE_RESULTS:	return "TDS_NO_MORE_RESULTS";
 	case TDS_CANCELLED:		return "TDS_CANCELLED";
 	default:
-		sprintf(unknown, "%u ??", retcode);
+		sprintf(unknown, "oops: %u ??", retcode);
 	}
 	return unknown;
 }
@@ -1530,7 +1530,7 @@ prretcode(int retcode)
 static const char *
 prresult_type(int result_type)
 {
-	static char unknown[12]="oops";
+	static char unknown[24];
 	switch(result_type) {
 	case TDS_ROW_RESULT:		return "TDS_ROW_RESULT";
 	case TDS_PARAM_RESULT:		return "TDS_PARAM_RESULT";
@@ -1548,7 +1548,7 @@ prresult_type(int result_type)
 	case TDS_DONEINPROC_RESULT:	return "TDS_DONEINPROC_RESULT";
 	case TDS_OTHERS_RESULT:		return "TDS_OTHERS_RESULT";
 	default:
-		sprintf(unknown, "%u ??", result_type);
+		sprintf(unknown, "oops: %u ??", result_type);
 	}
 	return unknown;
 }
diff --git a/src/dblib/dbutil.c b/src/dblib/dbutil.c
index 92ad3f5..da87bf4 100644
--- a/src/dblib/dbutil.c
+++ b/src/dblib/dbutil.c
@@ -39,7 +39,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dbutil.c,v 1.43 2008/08/17 07:44:45 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dbutil.c,v 1.44 2008/12/03 08:37:11 freddy77 Exp $");
 
 /*
  * test include consistency 
@@ -105,8 +105,8 @@ _dblib_handle_info_message(const TDSCONTEXT * tds_ctx, TDSSOCKET * tds, TDSMESSA
 		 * server messages with severity greater than 10.
 		 */
 		/* Cannot call dbperror() here because server messsage numbers (and text) are not in its lookup table. */
-		static char message[] = "General SQL Server error: Check messages from the SQL Server";
-		(*_dblib_err_handler)(dbproc, msg->severity, msg->msgno, 0, message, NULL);
+		static const char message[] = "General SQL Server error: Check messages from the SQL Server";
+		(*_dblib_err_handler)(dbproc, msg->severity, msg->msgno, 0, (char *) message, NULL);
 	}
 	return SUCCEED;
 }
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 2ba97b9..b44ce5f 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.505 2008/11/05 19:23:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.506 2008/12/03 08:37:11 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -155,10 +155,8 @@ static void odbc_ird_check(TDS_STMT * stmt);
  */
 
 static char *
-odbc_prret(SQLRETURN ret)
+odbc_prret(SQLRETURN ret, char *unknown)
 {
-	static char unknown[32];
-	
 	switch (ret) {
 	case SQL_ERROR:			return "SQL_ERROR";
 	case SQL_INVALID_HANDLE:	return "SQL_INVALID_HANDLE";
@@ -175,6 +173,8 @@ odbc_prret(SQLRETURN ret)
 
 	return unknown;
 }
+#define ODBC_PRRET_BUF	char unknown_prret_buf[24]
+#define odbc_prret(ret) odbc_prret(ret, unknown_prret_buf)
 
 static void
 odbc_col_setname(TDS_STMT * stmt, int colpos, const char *name)
@@ -3315,6 +3315,7 @@ SQLExecDirect(SQLHSTMT hstmt, SQLCHAR FAR * szSqlStr, SQLINTEGER cbSqlStr)
 SQLRETURN ODBC_API
 SQLExecute(SQLHSTMT hstmt)
 {
+	ODBC_PRRET_BUF;
 	SQLRETURN res;
 
 	INIT_HSTMT;
@@ -5890,6 +5891,7 @@ _SQLParamData(SQLHSTMT hstmt, SQLPOINTER FAR * prgbValue)
 SQLRETURN ODBC_API
 SQLParamData(SQLHSTMT hstmt, SQLPOINTER FAR * prgbValue)
 {
+	ODBC_PRRET_BUF;
 	SQLRETURN ret = _SQLParamData(hstmt, prgbValue);
 	
 	tdsdump_log(TDS_DBG_FUNC, "SQLParamData returns %s\n", odbc_prret(ret));
@@ -5900,6 +5902,7 @@ SQLParamData(SQLHSTMT hstmt, SQLPOINTER FAR * prgbValue)
 SQLRETURN ODBC_API
 SQLPutData(SQLHSTMT hstmt, SQLPOINTER rgbValue, SQLLEN cbValue)
 {
+	ODBC_PRRET_BUF;
 	INIT_HSTMT;
 
 	tdsdump_log(TDS_DBG_FUNC, "SQLPutData(%p, %p, %i)\n", hstmt, rgbValue, (int)cbValue);

